var NAVTREE =
[
  [ "ViSP", "index.html", [
    [ "Online documentation for ViSP 2.8.0", "index.html", [
      [ "Introduction", "index.html#intro_sec", null ],
      [ "Download", "index.html#download_sec", null ],
      [ "Installation", "index.html#install_sec", null ],
      [ "Tutorials", "index.html#Tutorial_sec", null ],
      [ "Using ViSP", "index.html#Examples_sec", null ],
      [ "How to help ?", "index.html#Howto_sec", null ]
    ] ],
    [ "Tutorial: Camera calibration", "d4/d23/tutorial-calibration.html", [
      [ "Introduction", "d4/d23/tutorial-calibration.html#calibration_intro", null ],
      [ "Source code", "d4/d23/tutorial-calibration.html#calibration_source_code", null ],
      [ "Calibration from a chessboard", "d4/d23/tutorial-calibration.html#calibration_chessboard", null ],
      [ "Calibration from a circle grid", "d4/d23/tutorial-calibration.html#calibration_circle", null ],
      [ "Distorsion removal", "d4/d23/tutorial-calibration.html#calibration_undistort", null ]
    ] ],
    [ "Tutorial: Getting started for iOS", "d4/d77/tutorial-getting-started-iOS.html", [
      [ "Add ViSP library into your project", "d4/d77/tutorial-getting-started-iOS.html#getting-started-iOS-add", null ],
      [ "Copy ViSP header into your project", "d4/d77/tutorial-getting-started-iOS.html#getting-started-iOS-copy", null ],
      [ "Use ViSP in your project", "d4/d77/tutorial-getting-started-iOS.html#getting-started-iOS-use", null ]
    ] ],
    [ "Tutorial: Getting started", "de/d13/tutorial-getting-started.html", [
      [ "Create a program using ViSP", "de/d13/tutorial-getting-started.html#image_code", null ],
      [ "Create a CMake file", "de/d13/tutorial-getting-started.html#image_cmake", null ],
      [ "On Unix-like systems", "de/d13/tutorial-getting-started.html#image_unix", [
        [ "Configure your project", "de/d13/tutorial-getting-started.html#image_unix_config", null ],
        [ "Generate the executable", "de/d13/tutorial-getting-started.html#image_unix_build", null ],
        [ "Run the executable", "de/d13/tutorial-getting-started.html#image_unix_output", null ]
      ] ],
      [ "On Windows", "de/d13/tutorial-getting-started.html#image_win", [
        [ "Configure your project", "de/d13/tutorial-getting-started.html#image_win_config", null ],
        [ "Generate the executable", "de/d13/tutorial-getting-started.html#image_win_build", null ],
        [ "Run the executable", "de/d13/tutorial-getting-started.html#image_win_output", null ]
      ] ]
    ] ],
    [ "Tutorial: Image frame grabbing", "dc/d8f/tutorial-grabber.html", [
      [ "Images from firewire cameras", "dc/d8f/tutorial-grabber.html#grabber-camera-firewire-unix", null ],
      [ "Images from other cameras", "dc/d8f/tutorial-grabber.html#grabber-camera-other", null ],
      [ "Images from a video stream", "dc/d8f/tutorial-grabber.html#grabber-video-stream", null ]
    ] ],
    [ "Tutorial: Image-based visual servo", "db/d8c/tutorial-ibvs.html", [
      [ "Introduction", "db/d8c/tutorial-ibvs.html#ibvs_intro", null ],
      [ "Basic IBVS simulation", "db/d8c/tutorial-ibvs.html#ibvs_basic", null ],
      [ "IBVS simulation with basic viewers", "db/d8c/tutorial-ibvs.html#ibvs_display", null ],
      [ "IBVS simulation with wireframe viewers", "db/d8c/tutorial-ibvs.html#ibvs_wireframe", null ],
      [ "IBVS simulation with image processing", "db/d8c/tutorial-ibvs.html#ibvs_tracking", null ]
    ] ],
    [ "Tutorial: Installation from source on OSX for iOS devices", "d8/d04/tutorial-install-iOS.html", [
      [ "Required software", "d8/d04/tutorial-install-iOS.html#install_iOS_required", null ],
      [ "Getting ViSP source code", "d8/d04/tutorial-install-iOS.html#install_iOS_get_source", null ],
      [ "Configuring ViSP from source", "d8/d04/tutorial-install-iOS.html#install_iOS_config", [
        [ "Optional 3rd party packages", "d8/d04/tutorial-install-iOS.html#install_iOS_3rdparty", null ],
        [ "Generate Xcode project", "d8/d04/tutorial-install-iOS.html#install_iOS_generate_xcode", null ]
      ] ],
      [ "Building ViSP library", "d8/d04/tutorial-install-iOS.html#install_iOS_build", [
        [ "Open and configure ViSP Xcode project", "d8/d04/tutorial-install-iOS.html#getting-started-iOS-configure", null ],
        [ "Generate ViSP library", "d8/d04/tutorial-install-iOS.html#getting-started-iOS-generate", null ]
      ] ]
    ] ],
    [ "Tutorial: Installation from source on Linux Ubuntu", "d1/d3f/tutorial-install-ubuntu.html", [
      [ "Required packages", "d1/d3f/tutorial-install-ubuntu.html#install_ubuntu_required", null ],
      [ "Getting ViSP source code", "d1/d3f/tutorial-install-ubuntu.html#install_ubuntu_get_source", null ],
      [ "Configuring ViSP from source", "d1/d3f/tutorial-install-ubuntu.html#install_ubuntu_config", [
        [ "Optional 3rd party packages", "d1/d3f/tutorial-install-ubuntu.html#install_ubuntu_3rdparty", null ],
        [ "Generating Makefiles", "d1/d3f/tutorial-install-ubuntu.html#install_ubuntu_generate", null ]
      ] ],
      [ "Building ViSP from source", "d1/d3f/tutorial-install-ubuntu.html#install_ubuntu_build", null ]
    ] ],
    [ "Tutorial: Installation from source on Windows", "d5/d2a/tutorial-install-win.html", [
      [ "Required packages", "d5/d2a/tutorial-install-win.html#install_win_required", null ],
      [ "Getting ViSP source code", "d5/d2a/tutorial-install-win.html#install_win_get_source", null ],
      [ "Configuring ViSP from source", "d5/d2a/tutorial-install-win.html#install_win_config", [
        [ "Optional 3rd party packages", "d5/d2a/tutorial-install-win.html#install_win_3rdparty", [
          [ "OpenCV 3rd party", "d5/d2a/tutorial-install-win.html#install_win_3rdparty_opencv", null ],
          [ "Ogre3D 3rd party", "d5/d2a/tutorial-install-win.html#install_win_3rdparty_ogre", null ]
        ] ],
        [ "Ending the configuration", "d5/d2a/tutorial-install-win.html#install_win_gene", null ]
      ] ],
      [ "Building ViSP from source", "d5/d2a/tutorial-install-win.html#install_win_build", null ],
      [ "Setting up PATH variable", "d5/d2a/tutorial-install-win.html#install_win_env_var", null ],
      [ "Appendix", "d5/d2a/tutorial-install-win.html#install_win_annex", [
        [ "Installing testing data", "d5/d2a/tutorial-install-win.html#install_annex_data", null ],
        [ "Using testing data", "d5/d2a/tutorial-install-win.html#install_annex_usage", null ]
      ] ]
    ] ],
    [ "Tutorial: Real-time curves plotter tool", "d2/d43/tutorial-plotter.html", null ],
    [ "Tutorial: Pose estimation from points", "d1/d9d/tutorial-pose-estimation.html", [
      [ "Introduction", "d1/d9d/tutorial-pose-estimation.html#tutorial_pose_intro", null ],
      [ "Pose estimation from 4 planar points", "d1/d9d/tutorial-pose-estimation.html#tutorial_pose_est", null ]
    ] ],
    [ "Tutorial: Planar image projection", "de/df7/tutorial-simu-image.html", [
      [ "Introduction", "de/df7/tutorial-simu-image.html#simu_image_intro", null ],
      [ "Image projection", "de/df7/tutorial-simu-image.html#simu_image_projection", null ]
    ] ],
    [ "Tutorial: Visual servo simulation on a pioneer-like unicycle robot", "d5/dfa/tutorial-simu-robot-pioneer.html", [
      [ "Unicycle with a fixed camera", "d5/dfa/tutorial-simu-robot-pioneer.html#simu_robot_pioneer_camera", null ],
      [ "Unicycle with a moving camera", "d5/dfa/tutorial-simu-robot-pioneer.html#simu_robot_pioneer_camera_pan", null ]
    ] ],
    [ "Tutorial: Blob tracking", "d9/d7d/tutorial-tracking-blob.html", [
      [ "Blob tracking", "d9/d7d/tutorial-tracking-blob.html#tracking_blob_tracking", null ],
      [ "Blob auto detection and tracking", "d9/d7d/tutorial-tracking-blob.html#tracking_blob_auto", null ]
    ] ],
    [ "Tutorial: Keypoint tracking", "d8/d59/tutorial-tracking-keypoint.html", [
      [ "KLT tracker", "d8/d59/tutorial-tracking-keypoint.html#tracking_keypoint_klt", null ]
    ] ],
    [ "Tutorial: Model-based tracking", "dd/dc7/tutorial-tracking-mb.html", [
      [ "Model-based edges tracker", "dd/dc7/tutorial-tracking-mb.html#tracking_mb_edges", null ],
      [ "Model-based KLT tracker", "dd/dc7/tutorial-tracking-mb.html#tracking_mb_klt", null ],
      [ "Model-based hybrid tracker", "dd/dc7/tutorial-tracking-mb.html#tracking_mb_hybrid", null ],
      [ "CAD model in cao format", "dd/dc7/tutorial-tracking-mb.html#tracking_mb_cao", [
        [ "teabox.cao example", "dd/dc7/tutorial-tracking-mb.html#tracking_mb_cao_face", null ],
        [ "teabox-triangle.cao example", "dd/dc7/tutorial-tracking-mb.html#tracking_mb_cao_triangle", null ]
      ] ]
    ] ],
    [ "Tutorial: Moving-edges tracking", "de/d1e/tutorial-tracking-me.html", [
      [ "Line tracking", "de/d1e/tutorial-tracking-me.html#tracking_me_line", null ],
      [ "Ellipse tracking", "de/d1e/tutorial-tracking-me.html#tracking_me_ellipse", null ]
    ] ],
    [ "Todo List", "dd/da0/todo.html", null ],
    [ "Deprecated List", "da/d58/deprecated.html", null ],
    [ "Bibliography", "d0/de3/citelist.html", null ],
    [ "Modules", "modules.html", "modules" ],
    [ "Classes", null, [
      [ "Class List", "annotated.html", "annotated" ],
      [ "Class Index", "classes.html", null ],
      [ "Class Hierarchy", "hierarchy.html", "hierarchy" ],
      [ "Class Members", "functions.html", [
        [ "All", "functions.html", "functions_dup" ],
        [ "Functions", "functions_func.html", "functions_func" ],
        [ "Variables", "functions_vars.html", "functions_vars" ],
        [ "Enumerations", "functions_enum.html", null ],
        [ "Enumerator", "functions_eval.html", "functions_eval" ],
        [ "Related Functions", "functions_rela.html", null ]
      ] ]
    ] ],
    [ "Examples", "examples.html", "examples" ]
  ] ]
];

var NAVTREEINDEX =
[
"annotated.html",
"d0/d31/classvpSimulatorViper850.html#a32cb399cfb99b0911a2780c94ac55269",
"d0/d31/classvpSimulatorViper850.html#a99e02e238e1e8e5dfc62411f850d65e8",
"d0/d35/classvpMbTracker.html#a1e579b001639f31288cb96650daffaa4",
"d0/db2/classvpGenericFeature.html#a45b8f5e6e41e7d21241ef46cd4ee4ee2",
"d1/d15/classvpTranslationVector.html#a29290bf950437824f5ccbfc64c97a7b6",
"d1/d22/classvpMeSite.html#ab90c6d919041141507c011c1ccd733aa",
"d1/d61/classvpMatrix.html#a0e90c5532769008a25b864b939c399fb",
"d1/dd8/servoAfma6Ellipse2DCamVelocity_8cpp-example.html",
"d2/d75/classvpRobotWireFrameSimulator.html#a9a1fb61066738a89c087a702ce5540d9",
"d2/d85/classvpColVector.html#a93ffcb402b06a1f63b66cac1c68c62d1",
"d2/da2/classvpSimulatorAfma6.html#a3df0a6a3086f42549009b96409321849",
"d2/da2/classvpSimulatorAfma6.html#ab6cefef0e26e52f8961324eca1637e86",
"d2/db6/classvpKltOpencv.html#ab1ffde19858303c9e4c2f411b3c2a563",
"d3/d82/classvpViper650.html#a2c281c5a16bf030443644350e0458891",
"d3/dc6/classvp1394TwoGrabber.html#a9838337d1885446c1110bb1401ff8602",
"d4/d02/test1394TwoResetBus_8cpp-example.html",
"d4/dbc/classvpRowVector.html#a12a2e67c896de6def537934968e13ee0",
"d5/d21/classvpImage.html#aaa48fc37077fe8c985a930dea410db76",
"d5/d66/classvpPoseVector.html#aadf602859330300b9340108128af8180",
"d5/db1/classvpCameraParameters.html#a5ea93cb059bdb1d084f19fb2182532e0",
"d6/d60/classvpXmlParserCamera.html#a5b38e16d138b3e391e5317b3e7c44dd4a17e06b2863f281762c58e43808b5c48b",
"d6/d67/classvpMbEdgeKltTracker.html#afabe29a3a049c9731cc50cef1382d6d1",
"d6/d93/classvpDisplayGDI.html#aa94fd1fad8b94266202824c6b438e157",
"d7/d92/classvpHistogram.html#aa4b3dff9434934124fc8d80c786efe85",
"d7/dd3/classvpDisplayOpenCV.html#a39d2b656129622fd8ff43e0ca3cb3012",
"d8/d01/classvpHomography.html#a54782ff338d1dfebdb5fae49b032aa08",
"d8/d8c/classvpFeatureMomentCentered.html#a23e303073b28cee9c9dd787c90f4b968",
"d8/ded/classvpAR.html#a2e0ce677e1ef769da131cb95ff9e1a4d",
"d9/d50/classvpViper850.html#a838b1d447c83419045848fdf016b02be",
"d9/d80/classvpFeatureThetaU.html#ac548c728fd17ab0d13b91378ae44b0b1ae8788a510161a3e1566fb73fa6e5257b",
"d9/daa/classvpRobotViper650.html#a2be76f1f995f53e1fd4ea468e88cff69",
"d9/ded/classvpCalibrationException.html#a8f31aec70760f34efc8c27357013253ea5efe03738d54bc95d2f0a34e7235b2e8",
"da/d24/classvpMbtPolygon.html#ab503a5136a75b0d553e93620cbcf7297",
"da/d5a/classvpImageException.html#a704888452465ce81e760c90e40d0e002",
"da/dd1/classvpSubColVector.html#a1d48bf87e99d164211210f3d958643dc",
"da/de5/classvpDisplay.html#a4149af6c425700a5f238a6ef0bb7c0e0",
"db/d0a/classvpHomogeneousMatrix.html#a29b15c6ef4cc3519777e2b6587d2644f",
"db/d38/classvp1394Grabber.html#ab540988f4eefb8a6a430aedaa2323a64",
"db/d8e/classvpDot.html#a15e4e33c5e5ef74ab1099232fb052084",
"db/dcd/displayOpenCV_8cpp-example.html",
"dc/d09/classvpSubRowVector.html#a29785baf4fbd27cf2f6ff0417b00e86c",
"dc/d50/classvpFeatureMomentCInvariant.html#a32b6cdaa6b20bc945d41f710d5fa537f",
"dc/d82/classvpSphere.html#afc2b37931e5f874bd038fb8961565812",
"dc/dde/classvpV4l2Grabber.html#a46fcba0f857b40e12069b2fc39974950a8eb9a8f2c18a46c4af6a7818ae55a4e7",
"dd/d72/classvpWireFrameSimulator.html#a0bd80708c0617988dfa2bc7949ce535b",
"dd/dd4/classvpServo.html#a2a92ea050512c23e38b84d5fefd56b07a43e2024e68173b2336e8a21909888f51",
"dd/df8/classvpRobotAfma6.html#abd34e25d5c461216636bea8bbb868853",
"de/d5a/classvpForceTwistMatrix.html#a3686fea8f128c71371b5c686d51c787e",
"de/dbb/classvpRobotCamera.html#a7a452501f61cf2947c8b8746387eff74",
"df/d0f/classvpDisplayWin32.html#a4810fb62a9eafbb06ff8171eb1d827a1",
"df/d33/classvpRobotViper850.html#a80c49233baa92b8ae34c32d9696cee6c",
"df/d4b/classvpFeatureEllipse.html#a1170a4420125e29d721f8d3fecf3cd03",
"df/de9/classvpSubMatrix.html#aec158337fb9b6badf9e3a8ca08401777"
];

var SYNCONMSG = 'click to disable panel synchronisation';
var SYNCOFFMSG = 'click to enable panel synchronisation';
var SYNCONMSG = 'click to disable panel synchronisation';
var SYNCOFFMSG = 'click to enable panel synchronisation';
var navTreeSubIndices = new Array();

function getData(varName)
{
  var i = varName.lastIndexOf('/');
  var n = i>=0 ? varName.substring(i+1) : varName;
  return eval(n.replace(/\-/g,'_'));
}

function stripPath(uri)
{
  return uri.substring(uri.lastIndexOf('/')+1);
}

function stripPath2(uri)
{
  var i = uri.lastIndexOf('/');
  var s = uri.substring(i+1);
  var m = uri.substring(0,i+1).match(/\/d\w\/d\w\w\/$/);
  return m ? uri.substring(i-6) : s;
}

function localStorageSupported()
{
  try {
    return 'localStorage' in window && window['localStorage'] !== null && window.localStorage.getItem;
  }
  catch(e) {
    return false;
  }
}


function storeLink(link)
{
  if (!$("#nav-sync").hasClass('sync') && localStorageSupported()) {
      window.localStorage.setItem('navpath',link);
  }
}

function deleteLink()
{
  if (localStorageSupported()) {
    window.localStorage.setItem('navpath','');
  } 
}

function cachedLink()
{
  if (localStorageSupported()) {
    return window.localStorage.getItem('navpath');
  } else {
    return '';
  }
}

function getScript(scriptName,func,show)
{
  var head = document.getElementsByTagName("head")[0]; 
  var script = document.createElement('script');
  script.id = scriptName;
  script.type = 'text/javascript';
  script.onload = func; 
  script.src = scriptName+'.js'; 
  if ($.browser.msie && $.browser.version<=8) { 
    // script.onload does not work with older versions of IE
    script.onreadystatechange = function() {
      if (script.readyState=='complete' || script.readyState=='loaded') { 
        func(); if (show) showRoot(); 
      }
    }
  }
  head.appendChild(script); 
}

function createIndent(o,domNode,node,level)
{
  var level=-1;
  var n = node;
  while (n.parentNode) { level++; n=n.parentNode; }
  if (node.childrenData) {
    var imgNode = document.createElement("img");
    imgNode.style.paddingLeft=(16*level).toString()+'px';
    imgNode.width  = 16;
    imgNode.height = 22;
    imgNode.border = 0;
    node.plus_img = imgNode;
    node.expandToggle = document.createElement("a");
    node.expandToggle.href = "javascript:void(0)";
    node.expandToggle.onclick = function() {
      if (node.expanded) {
        $(node.getChildrenUL()).slideUp("fast");
        node.plus_img.src = node.relpath+"ftv2pnode.png";
        node.expanded = false;
      } else {
        expandNode(o, node, false, false);
      }
    }
    node.expandToggle.appendChild(imgNode);
    domNode.appendChild(node.expandToggle);
    imgNode.src = node.relpath+"ftv2pnode.png";
  } else {
    var span = document.createElement("span");
    span.style.display = 'inline-block';
    span.style.width   = 16*(level+1)+'px';
    span.style.height  = '22px';
    span.innerHTML = '&#160;';
    domNode.appendChild(span);
  } 
}

var animationInProgress = false;

function gotoAnchor(anchor,aname,updateLocation)
{
  var pos, docContent = $('#doc-content');
  if (anchor.parent().attr('class')=='memItemLeft' ||
      anchor.parent().attr('class')=='fieldtype' ||
      anchor.parent().is(':header')) 
  {
    pos = anchor.parent().position().top;
  } else if (anchor.position()) {
    pos = anchor.position().top;
  }
  if (pos) {
    var dist = Math.abs(Math.min(
               pos-docContent.offset().top,
               docContent[0].scrollHeight-
               docContent.height()-docContent.scrollTop()));
    animationInProgress=true;
    docContent.animate({
      scrollTop: pos + docContent.scrollTop() - docContent.offset().top
    },Math.max(50,Math.min(500,dist)),function(){
      if (updateLocation) window.location.href=aname;
      animationInProgress=false;
    });
  }
}

function newNode(o, po, text, link, childrenData, lastNode)
{
  var node = new Object();
  node.children = Array();
  node.childrenData = childrenData;
  node.depth = po.depth + 1;
  node.relpath = po.relpath;
  node.isLast = lastNode;

  node.li = document.createElement("li");
  po.getChildrenUL().appendChild(node.li);
  node.parentNode = po;

  node.itemDiv = document.createElement("div");
  node.itemDiv.className = "item";

  node.labelSpan = document.createElement("span");
  node.labelSpan.className = "label";

  createIndent(o,node.itemDiv,node,0);
  node.itemDiv.appendChild(node.labelSpan);
  node.li.appendChild(node.itemDiv);

  var a = document.createElement("a");
  node.labelSpan.appendChild(a);
  node.label = document.createTextNode(text);
  node.expanded = false;
  a.appendChild(node.label);
  if (link) {
    var url;
    if (link.substring(0,1)=='^') {
      url = link.substring(1);
      link = url;
    } else {
      url = node.relpath+link;
    }
    a.className = stripPath(link.replace('#',':'));
    if (link.indexOf('#')!=-1) {
      var aname = '#'+link.split('#')[1];
      var srcPage = stripPath($(location).attr('pathname'));
      var targetPage = stripPath(link.split('#')[0]);
      a.href = srcPage!=targetPage ? url : "javascript:void(0)"; 
      a.onclick = function(){
        storeLink(link);
        if (!$(a).parent().parent().hasClass('selected'))
        {
          $('.item').removeClass('selected');
          $('.item').removeAttr('id');
          $(a).parent().parent().addClass('selected');
          $(a).parent().parent().attr('id','selected');
        }
        var anchor = $(aname);
        gotoAnchor(anchor,aname,true);
      };
    } else {
      a.href = url;
      a.onclick = function() { storeLink(link); }
    }
  } else {
    if (childrenData != null) 
    {
      a.className = "nolink";
      a.href = "javascript:void(0)";
      a.onclick = node.expandToggle.onclick;
    }
  }

  node.childrenUL = null;
  node.getChildrenUL = function() {
    if (!node.childrenUL) {
      node.childrenUL = document.createElement("ul");
      node.childrenUL.className = "children_ul";
      node.childrenUL.style.display = "none";
      node.li.appendChild(node.childrenUL);
    }
    return node.childrenUL;
  };

  return node;
}

function showRoot()
{
  var headerHeight = $("#top").height();
  var footerHeight = $("#nav-path").height();
  var windowHeight = $(window).height() - headerHeight - footerHeight;
  (function (){ // retry until we can scroll to the selected item
    try {
      var navtree=$('#nav-tree');
      navtree.scrollTo('#selected',0,{offset:-windowHeight/2});
    } catch (err) {
      setTimeout(arguments.callee, 0);
    }
  })();
}

function expandNode(o, node, imm, showRoot)
{
  if (node.childrenData && !node.expanded) {
    if (typeof(node.childrenData)==='string') {
      var varName    = node.childrenData;
      getScript(node.relpath+varName,function(){
        node.childrenData = getData(varName);
        expandNode(o, node, imm, showRoot);
      }, showRoot);
    } else {
      if (!node.childrenVisited) {
        getNode(o, node);
      } if (imm || ($.browser.msie && $.browser.version>8)) { 
        // somehow slideDown jumps to the start of tree for IE9 :-(
        $(node.getChildrenUL()).show();
      } else {
        $(node.getChildrenUL()).slideDown("fast");
      }
      if (node.isLast) {
        node.plus_img.src = node.relpath+"ftv2mlastnode.png";
      } else {
        node.plus_img.src = node.relpath+"ftv2mnode.png";
      }
      node.expanded = true;
    }
  }
}

function glowEffect(n,duration)
{
  n.addClass('glow').delay(duration).queue(function(next){
    $(this).removeClass('glow');next();
  });
}

function highlightAnchor()
{
  var aname = $(location).attr('hash');
  var anchor = $(aname);
  if (anchor.parent().attr('class')=='memItemLeft'){
    var rows = $('.memberdecls tr[class$="'+
               window.location.hash.substring(1)+'"]');
    glowEffect(rows.children(),300); // member without details
  } else if (anchor.parents().slice(2).prop('tagName')=='TR') {
    glowEffect(anchor.parents('div.memitem'),1000); // enum value
  } else if (anchor.parent().attr('class')=='fieldtype'){
    glowEffect(anchor.parent().parent(),1000); // struct field
  } else if (anchor.parent().is(":header")) {
    glowEffect(anchor.parent(),1000); // section header
  } else {
    glowEffect(anchor.next(),1000); // normal member
  }
  gotoAnchor(anchor,aname,false);
}

function selectAndHighlight(hash,n)
{
  var a;
  if (hash) {
    var link=stripPath($(location).attr('pathname'))+':'+hash.substring(1);
    a=$('.item a[class$="'+link+'"]');
  }
  if (a && a.length) {
    a.parent().parent().addClass('selected');
    a.parent().parent().attr('id','selected');
    highlightAnchor();
  } else if (n) {
    $(n.itemDiv).addClass('selected');
    $(n.itemDiv).attr('id','selected');
  }
  if ($('#nav-tree-contents .item:first').hasClass('selected')) {
    $('#nav-sync').css('top','30px');
  } else {
    $('#nav-sync').css('top','5px');
  }
  showRoot();
}

function showNode(o, node, index, hash)
{
  if (node && node.childrenData) {
    if (typeof(node.childrenData)==='string') {
      var varName    = node.childrenData;
      getScript(node.relpath+varName,function(){
        node.childrenData = getData(varName);
        showNode(o,node,index,hash);
      },true);
    } else {
      if (!node.childrenVisited) {
        getNode(o, node);
      }
      $(node.getChildrenUL()).css({'display':'block'});
      if (node.isLast) {
        node.plus_img.src = node.relpath+"ftv2mlastnode.png";
      } else {
        node.plus_img.src = node.relpath+"ftv2mnode.png";
      }
      node.expanded = true;
      var n = node.children[o.breadcrumbs[index]];
      if (index+1<o.breadcrumbs.length) {
        showNode(o,n,index+1,hash);
      } else {
        if (typeof(n.childrenData)==='string') {
          var varName = n.childrenData;
          getScript(n.relpath+varName,function(){
            n.childrenData = getData(varName);
            node.expanded=false;
            showNode(o,node,index,hash); // retry with child node expanded
          },true);
        } else {
          var rootBase = stripPath(o.toroot.replace(/\..+$/, ''));
          if (rootBase=="index" || rootBase=="pages" || rootBase=="search") {
            expandNode(o, n, true, true);
          }
          selectAndHighlight(hash,n);
        }
      }
    }
  } else {
    selectAndHighlight(hash);
  }
}

function removeToInsertLater(element) {
  var parentNode = element.parentNode;
  var nextSibling = element.nextSibling;
  parentNode.removeChild(element);
  return function() {
    if (nextSibling) {
      parentNode.insertBefore(element, nextSibling);
    } else {
      parentNode.appendChild(element);
    }
  };
}

function getNode(o, po)
{
  var insertFunction = removeToInsertLater(po.li);
  po.childrenVisited = true;
  var l = po.childrenData.length-1;
  for (var i in po.childrenData) {
    var nodeData = po.childrenData[i];
    po.children[i] = newNode(o, po, nodeData[0], nodeData[1], nodeData[2],
      i==l);
  }
  insertFunction();
}

function gotoNode(o,subIndex,root,hash,relpath)
{
  var nti = navTreeSubIndices[subIndex][root+hash];
  o.breadcrumbs = $.extend(true, [], nti ? nti : navTreeSubIndices[subIndex][root]);
  if (!o.breadcrumbs && root!=NAVTREE[0][1]) { // fallback: show index
    navTo(o,NAVTREE[0][1],"",relpath);
    $('.item').removeClass('selected');
    $('.item').removeAttr('id');
  }
  if (o.breadcrumbs) {
    o.breadcrumbs.unshift(0); // add 0 for root node
    showNode(o, o.node, 0, hash);
  }
}

function navTo(o,root,hash,relpath)
{
  var link = cachedLink();
  if (link) {
    var parts = link.split('#');
    root = parts[0];
    if (parts.length>1) hash = '#'+parts[1];
    else hash='';
  }
  if (hash.match(/^#l\d+$/)) {
    var anchor=$('a[name='+hash.substring(1)+']');
    glowEffect(anchor.parent(),1000); // line number
    hash=''; // strip line number anchors
    //root=root.replace(/_source\./,'.'); // source link to doc link
  }
  var url=root+hash;
  var i=-1;
  while (NAVTREEINDEX[i+1]<=url) i++;
  if (i==-1) { i=0; root=NAVTREE[0][1]; } // fallback: show index
  if (navTreeSubIndices[i]) {
    gotoNode(o,i,root,hash,relpath)
  } else {
    getScript(relpath+'navtreeindex'+i,function(){
      navTreeSubIndices[i] = eval('NAVTREEINDEX'+i);
      if (navTreeSubIndices[i]) {
        gotoNode(o,i,root,hash,relpath);
      }
    },true);
  }
}

function showSyncOff(n,relpath)
{
    n.html('<img src="'+relpath+'sync_off.png" title="'+SYNCOFFMSG+'"/>');
}

function showSyncOn(n,relpath)
{
    n.html('<img src="'+relpath+'sync_on.png" title="'+SYNCONMSG+'"/>');
}

function toggleSyncButton(relpath)
{
  var navSync = $('#nav-sync');
  if (navSync.hasClass('sync')) {
    navSync.removeClass('sync');
    showSyncOff(navSync,relpath);
    storeLink(stripPath2($(location).attr('pathname'))+$(location).attr('hash'));
  } else {
    navSync.addClass('sync');
    showSyncOn(navSync,relpath);
    deleteLink();
  }
}

function initNavTree(toroot,relpath)
{
  var o = new Object();
  o.toroot = toroot;
  o.node = new Object();
  o.node.li = document.getElementById("nav-tree-contents");
  o.node.childrenData = NAVTREE;
  o.node.children = new Array();
  o.node.childrenUL = document.createElement("ul");
  o.node.getChildrenUL = function() { return o.node.childrenUL; };
  o.node.li.appendChild(o.node.childrenUL);
  o.node.depth = 0;
  o.node.relpath = relpath;
  o.node.expanded = false;
  o.node.isLast = true;
  o.node.plus_img = document.createElement("img");
  o.node.plus_img.src = relpath+"ftv2pnode.png";
  o.node.plus_img.width = 16;
  o.node.plus_img.height = 22;

  if (localStorageSupported()) {
    var navSync = $('#nav-sync');
    if (cachedLink()) {
      showSyncOff(navSync,relpath);
      navSync.removeClass('sync');
    } else {
      showSyncOn(navSync,relpath);
    }
    navSync.click(function(){ toggleSyncButton(relpath); });
  }

  $(window).load(function(){
    navTo(o,toroot,window.location.hash,relpath);
    showRoot();
  });

  $(window).bind('hashchange', function(){
     if (window.location.hash && window.location.hash.length>1){
       var a;
       if ($(location).attr('hash')){
         var clslink=stripPath($(location).attr('pathname'))+':'+
                               $(location).attr('hash').substring(1);
         a=$('.item a[class$="'+clslink+'"]');
       }
       if (a==null || !$(a).parent().parent().hasClass('selected')){
         $('.item').removeClass('selected');
         $('.item').removeAttr('id');
       }
       var link=stripPath2($(location).attr('pathname'));
       navTo(o,link,$(location).attr('hash'),relpath);
     } else if (!animationInProgress) {
       $('#doc-content').scrollTop(0);
       $('.item').removeClass('selected');
       $('.item').removeAttr('id');
       navTo(o,toroot,window.location.hash,relpath);
     }
  })
}

